#!/usr/bin/python

# this script outputs the resources page index.html
# required files: index.begin.ihtml, index.end.ihtml

import re

entries = (('The Mutopia Project', 'http://www.mutopiaproject.org', 'mutopia-logo.png',
            """The Mutopia Project includes free sheet music submitted by
volunteers, all available as Postscript (.ps) and PDF (.pdf)
files, for both A4 and Letter paper sizes, as well as Lilypond's
own file format (.ly)."""),
           ('LilyPond Snippet Repository (LSR)', 'http://lsr.dsi.unimi.it/', '',
            """LSR collects demonstrative examples, contributed by LilyPonders."""),
           ('Music Dictionary Online', 'http://www.dolmetsch.com/musictheorydefs.htm', '',
            """Music Dictionary Online
explains words and terms found in musical scores, books about music, web
sites on music, notes on CDs or in concert programmes."""),
           ('Graham Percival', 'http://percival-music.ca/', '',
            """Graham Percival posts his cello and viola
compositions."""),
           ('', 'http://www.schemers.org', 'schemers.org-logo.png',
            """The Scheme programming language is used in
LilyPond, both as part of the input syntax, and as an internal mechanism
to glue together modules of the program.  There are on-line books, such as
<a href=\"http://www.scheme.com/tspl2d/\">The Scheme Programming Language</a>."""),
           ('', 'http://www.svenax.net/', '',
            """Svenax has posted 100 bagpipe tunes in his sheet
music archive. Lily source is available at
<a href=\"svn://svenax.dynip.com/LilyMusic/Bagpipe\">svn://svenax.dynip.com/LilyMusic/Bagpipe</a>,
which needs <a href=\"http://subversion.tigris.org/\">Subversion</a>, which is easy to use through
the <a href=\"http://tortoisesvn.tigris.org/\">TortoiseSVN client</a>."""),
           ('jEdit', 'http://jedit.org/', 'jedit-logo.png',
            """jEdit is a text editor with a
<a href=\"http://plugins.jedit.org/plugins/?LilyPondTool\">LilyPondTool plugin</a> to
help build LilyPond scores. See the
<a href=\"http://lily4jedit.sourceforge.net/users-guide.html\">LilyPondTool User's
Guide</a>, especially <em>Chapter 2: Installation</em>, and subscribe to the
<a href=\"http://lists.sourceforge.net/lists/listinfo/lily4jedit-user\">user list</a>."""),
           ('LilyPad', 'http://edbaskerville.com/software/lilypad/', 'lilypad-logo.png',
            """LilyPad is a Mac OS X editor for LilyPond."""),
           ('A First Guide to PostScript',
            'http://www.cs.indiana.edu/docproject/programming/postscript/postscript.html', '',
            """This guide is an introduction to PostScript."""),
           ('Han-Wen Nienhuys', 'http://www.xs4all.nl/~hanwen/', '',
            """Han-Wen Nienhuys maintains some sheet music
<http://www.google.com/search?le=en&ie=UTF-8&oe=utf-8&q=pour+cor&btnG=Google+Search&num=20&sourceid=Mozilla-search><i>pour
cor</i></a>."""))

body = '<dl>\n'
for entry in entries:
	body += '<dt>'
        if entry[0] != '':
        	body += entry[0] + ' &ndash;\n'
	body += '<a href="' + entry[1] + '">' + entry[1] + '</a></dt>\n<dd>'
	if entry[2] !='':
		body += '<table borderwidth=0>\n <tr>\n' + \
			'  <td><a href="' + entry[1] + '"><img src="' + entry[2] + '"></a></td>\n' + \
			'  <td>' + entry[3] + '</td>\n </tr>\n</table><br></dd>\n\n' # add @IMAGES@ in img src?
	else:
		body += entry[3] + '</dd><br>\n\n'
body += '</dl>\n'

f = open('index.html.src', 'r')
page = f.read()
f.close()
page = """<!-- do not edit this file, changes will be lost;
     edit index.html.src and format-resources.py !-->""" + page
page = re.sub('@BODY@', body, page)

f = open('index.html', 'w')
f.write(page)
f.close()
